/*
A GLUT program NOT using GLSL, 

Orion Sky Lawlor, olawlor@acm.org, 2007/01/18 (Public Domain)
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#ifdef USE_MPIGLUT
#  include <GL/mpiglut.h>
#else
#  include <GL/glut.h> /* GL Utilities Toolkit, http://freeglut.sourceforge.net/ */
#endif

int win_w, win_h;

/* GLUT calls this routine every time our window needs to be redrawn */
void main_display(void) {
	// Clear the color and depth buffers
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); /* <- somebody's got to touch the projection matrix every resize at least */
	static float angle=0.0;
	glRotatef(angle,0,0,1); angle+=0.2;
	glutPostRedisplay();
	
	
	glEnable(GL_TEXTURE_2D);
		
	glBegin(GL_TRIANGLES);
	glColor3f(1.0,1.0,1); glTexCoord2d(0,0); glVertex3f(0,0,0);
	glColor3f(0.6,1.0,1); glTexCoord2d(8,0); glVertex3f(1,0,0);
	glColor3f(1.0,0.4,1); glTexCoord2d(0,8); glVertex3f(0,1,0);
	glEnd();
	
	// Display the stuff drawn so far to the screen:
	glutSwapBuffers();
	
	static double lastFrame=0;
	glFinish();  /* <- make graphics card catch up to CPU */
	double curFrame=0.001*glutGet(GLUT_ELAPSED_TIME);
	if (lastFrame>0) printf("%.3f s/frame\n",(curFrame-lastFrame));
	lastFrame=curFrame;
}

/* GLUT calls this routine every time our window changes size */
void main_reshape(int w, int h) {
	win_w=w; win_h=h;
	glViewport(0, 0, (GLsizei)win_w, (GLsizei)(win_h));
	printf("Resize to %dx%d\n", w,h);
}

int main(int argc, char** argv)
{
	int w=800, h=600;
	glutInit(&argc,argv);

	if (argc>1) sscanf(argv[1],"%dx%d",&w,&h);
	glutInitWindowSize(w,h);

	// Ask for a back buffer, color buffer, and Z buffer in a window.
	int mode=GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH;
	glutInitDisplayMode (mode);
	int main_window = glutCreateWindow("GL Perfmon Demo");

	// Ask GLUT to call us when we need to redraw
	glutDisplayFunc (main_display);
	glutReshapeFunc (main_reshape);
	

	{
	// Set up a little texture
	glEnable(GL_TEXTURE_2D);
	enum {w=2}; enum{h=2};
	unsigned char colors[4*w*h]={
		0xff,0x00,0x00,0xff,  0x00,0xff,0x00,0xff,
		0x00,0x00,0xff,0xff,  0xff,0xff,0xff,0x7f,
	};
	glTexImage2D(GL_TEXTURE_2D,
		0, // highest-level mipmap
		GL_RGBA8, // internal format
		w,h, // size of texture in pixels
		0, // border
		GL_RGBA, // format of my pixels
		GL_UNSIGNED_BYTE, // data type is unsigned char
		colors);
	GLenum target=GL_TEXTURE_2D;
	glTexParameteri(target, GL_TEXTURE_WRAP_S, GL_REPEAT); 
	glTexParameteri(target, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(target, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(target, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	}
	
	// Process events until user closes our window...
	glutMainLoop();
	
	return 0;
}
